using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;

namespace UnifiedPOS.RFIDScanner.V1_4
{
    [ServiceContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public interface RFIDScanner
    {
        #region Version 1.1

        //
        // Common Properties
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetAutoDisable", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetAutoDisableResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        bool GetAutoDisable(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/SetAutoDisable", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/SetAutoDisableResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void SetAutoDisable(string ConsumerID, bool AutoDisable);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCapCompareFirmwareVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCapCompareFirmwareVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        bool GetCapCompareFirmwareVersion(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCapPowerReporting", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCapPowerReportingResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        PowerReporting GetCapPowerReporting(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCapStatisticsReporting", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCapStatisticsReportingResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        bool GetCapStatisticsReporting(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCapUpdateFirmware", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCapUpdateFirmwareResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        bool GetCapUpdateFirmware(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCapUpdateStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCapUpdateStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        bool GetCapUpdateStatistics(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCheckHealthText", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCheckHealthTextResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        string GetCheckHealthText(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetClaimed", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetClaimedResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        bool GetClaimed(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetDataCount", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetDataCountResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        int GetDataCount(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetDataEventEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetDataEventEnabledResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        bool GetDataEventEnabled(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/SetDataEventEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/SetDataEventEnabledResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void SetDataEventEnabled(string ConsumerID, bool DataEventEnabled);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetDeviceEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetDeviceEnabledResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        bool GetDeviceEnabled(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/SetDeviceEnabled", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/SetDeviceEnabledResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void SetDeviceEnabled(string ConsumerID, bool DeviceEnabled);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetFreezeEvents", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetFreezeEventsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        bool GetFreezeEvents(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/SetFreezeEvents", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/SetFreezeEventsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void SetFreezeEvents(string ConsumerID, bool FreezeEvents);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetOutputID", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetOutputIDResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        int GetOutputID(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetPowerNotify", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetPowerNotifyResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        PowerNotification GetPowerNotify(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/SetPowerNotify", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/SetPowerNotifyResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void SetPowerNotify(string ConsumerID, PowerNotification PowerNotify);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetPowerState", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetPowerStateResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        PowerState GetPowerState(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetState", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetStateResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        ControlState GetState(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetDeviceControlDescription", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetDeviceControlDescriptionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        string GetDeviceControlDescription(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetDeviceControlVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetDeviceControlVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        UposVersion GetDeviceControlVersion(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetDeviceServiceDescription", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetDeviceServiceDescriptionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        string GetDeviceServiceDescription(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetDeviceServiceVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetDeviceServiceVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        UposVersion GetDeviceServiceVersion(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetPhysicalDeviceDescription", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetPhysicalDeviceDescriptionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        string GetPhysicalDeviceDescription(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetPhysicalDeviceName", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetPhysicalDeviceNameResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        string GetPhysicalDeviceName(string ConsumerID);

        //
        // Specific Properties
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCapContinuousRead", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCapContinuousReadResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        bool GetCapContinuousRead(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCapDisableTag", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCapDisableTagResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        bool GetCapDisableTag(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCapLockTag", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCapLockTagResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        bool GetCapLockTag(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCapMultipleProtocols", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCapMultipleProtocolsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        int GetCapMultipleProtocols(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCapReadTimer", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCapReadTimerResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        bool GetCapReadTimer(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCapWriteTag", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCapWriteTagResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        WriteTagSections GetCapWriteTag(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetContinuousReadMode", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetContinuousReadModeResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        bool GetContinuousReadMode(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCurrentTagID", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCurrentTagIDResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        byte[] GetCurrentTagID(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCurrentTagProtocol", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCurrentTagProtocolResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        int GetCurrentTagProtocol(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCurrentTagUserData", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetCurrentTagUserDataResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        byte[] GetCurrentTagUserData(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetProtocolMask", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetProtocolMaskResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        int GetProtocolMask(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/SetProtocolMask", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/SetProtocolMaskResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void SetProtocolMask(string ConsumerID, int ProtocolMask);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetReadTimerInterval", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetReadTimerIntervalResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        int GetReadTimerInterval(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/SetReadTimerInterval", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/SetReadTimerIntervalResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void SetReadTimerInterval(string ConsumerID, int ReadTimerInterval);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetTagCount", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetTagCountResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        int GetTagCount(string ConsumerID);

        //
        // Common Methods
        //

        //[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/Open", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/OpenResponse")]
        //[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        //void Open(string ConsumerID, string EndpointAddress);

        //[OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/Close", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/CloseResponse")]
        //[FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        //void Close(string ConsumerID, string EndpointAddress);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/Claim", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/ClaimResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void Claim(string ConsumerID, int Timeout);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/Release", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/ReleaseResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void Release(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/CheckHealth", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/CheckHealthResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void CheckHealth(string ConsumerID, HealthCheckLevel Level);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/ClearInput", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/ClearInputResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void ClearInput(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/ClearInputProperties", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/ClearInputPropertiesResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void ClearInputProperties(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/ClearOutput", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/ClearOutputResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void ClearOutput(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/DirectIO", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/DirectIOResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        DirectIOData DirectIO(string ConsumerID, int Command, int Data, object Obj);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/CompareFirmwareVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/CompareFirmwareVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        CompareFirmwareResult CompareFirmwareVersion(string ConsumerID, string FirmwareFileName);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/ResetStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/ResetStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void ResetStatistics(string ConsumerID, StatisticList StatisticsBuffer);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/RetrieveStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/RetrieveStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        string RetrieveStatistics(string ConsumerID, StatisticList StatisticsBuffer);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UpdateFirmware", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UpdateFirmwareResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void UpdateFirmware(string ConsumerID, string FirmwareFileName);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UpdateStatistics", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UpdateStatisticsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void UpdateStatistics(string ConsumerID, StatisticList StatisticsBuffer);

        //
        // Specific Methods
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/DisableTag", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/DisableTagResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void DisableTag(string ConsumerID, byte[] TagID, int Timeout, byte[] Password);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/FirstTag", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/FirstTagResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void FirstTag(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/LockTag", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/LockTagResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void LockTag(string ConsumerID, byte[] TagID, int Timeout, byte[] Password);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/NextTag", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/NextTagResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void NextTag(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/PreviousTag", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/PreviousTagResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void PreviousTag(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/ReadTags", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/ReadTagsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void ReadTags(string ConsumerID, RFIDReadOptions Cmd, byte[] FilterID, byte[] FilterMask, int Start, int Length, int Timeout, byte[] Password);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/StartReadTags", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/StartReadTagsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void StartReadTags(string ConsumerID, RFIDReadOptions Cmd, byte[] FilterID, byte[] FilterMask, int Start, int Length, byte[] Password);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/StopReadTags", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/StopReadTagsResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void StopReadTags(string ConsumerID, byte[] Password);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/WriteTagData", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/WriteTagDataResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void WriteTagData(string ConsumerID, byte[] TagID, byte[] UserData, int Start, int Timeout, byte[] Password);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/WriteTagID", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/WriteTagIDResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void WriteTagID(string ConsumerID, byte[] SourceTagID, byte[] DestinationTagID, int Timeout, byte[] Password);

        #endregion

        #region Version 1.2

        //
        // Session Management
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetWSPOSVersion", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetWSPOSVersionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        UposVersion GetWSPOSVersion();

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GenerateConsumerID", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GenerateConsumerIDResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        string GenerateConsumerID();

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/OpenSession", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/OpenSessionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void OpenSession(string ConsumerID, string EndpointAddress);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/CloseSession", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/CloseSessionResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void CloseSession(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetProviderSessionTimeout", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetProviderSessionTimeoutResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        int GetProviderSessionTimeout(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/KeepAlive", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/KeepAliveResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void KeepAlive(string ConsumerID);

        //
        // Device Control
        // 

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/OpenDevice", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/OpenDeviceResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void OpenDevice(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/CloseDevice", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/CloseDeviceResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void CloseDevice(string ConsumerID);

        //
        // Event Polling
        //

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/PollForUPOSEvent", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/PollForUPOSEventResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        RFIDScannerEvent PollForUPOSEvent(string ConsumerID);

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/SetEventResponse", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/SetEventResponseResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void SetEventResponse(string ConsumerID, RFIDScannerEventResponse EventResponse);

        #endregion

        #region Version 1.3

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetEncryptedClaimedConsumerID", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/GetEncryptedClaimedConsumerIDResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        string GetEncryptedClaimedConsumerID();

        [OperationContract(Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/SetEventRequestProperties", ReplyAction = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/SetEventRequestPropertiesResponse")]
        [FaultContract(typeof(UposException), Action = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/UposException", Name = "UposException")]
        void SetEventRequestProperties(string ConsumerID, PropertyNameList list);

        #endregion
    }

    #region Version 1.1

    //
    // Common Data Types
    //

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public class DirectIOData
    {
        [DataMember]
        public int Data { get; set; }
        [DataMember]
        public object Obj { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public class UposException
    {
        [DataMember]
        public ErrorCode ErrorCode { get; set; }
        [DataMember]
        public int ErrorCodeExtended { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public class UposVersion
    {
        [DataMember]
        public int Major { get; set; }
        [DataMember]
        public int Minor { get; set; }
        [DataMember]
        public int Build { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public class Statistic
    {
        [DataMember]
        public string Name { get; set; }
        [DataMember]
        public string Value { get; set; }
    }

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/", ItemName = "Statistic")]
    public class StatisticList : List<Statistic>
    {
    }

    //
    // Common Enumerations
    //

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public enum CompareFirmwareResult
    {
        [EnumMember]
        CFV_FIRMWARE_OLDER,
        [EnumMember]
        CFV_FIRMWARE_SAME,
        [EnumMember]
        CFV_FIRMWARE_NEWER,
        [EnumMember]
        CFV_FIRMWARE_DIFFERENT,
        [EnumMember]
        CFV_FIRMWARE_UNKNOWN,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public enum ControlState
    {
        [EnumMember]
        S_CLOSED,
        [EnumMember]
        S_IDLE,
        [EnumMember]
        S_BUSY,
        [EnumMember]
        S_ERROR,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public enum ErrorCode
    {
        [EnumMember]
        E_CLOSED,
        [EnumMember]
        E_CLAIMED,
        [EnumMember]
        E_NOTCLAIMED,
        [EnumMember]
        E_NOSERVICE,
        [EnumMember]
        E_DISABLED,
        [EnumMember]
        E_ILLEGAL,
        [EnumMember]
        E_NOHARDWARE,
        [EnumMember]
        E_OFFLINE,
        [EnumMember]
        E_NOEXIST,
        [EnumMember]
        E_EXISTS,
        [EnumMember]
        E_FAILURE,
        [EnumMember]
        E_TIMEOUT,
        [EnumMember]
        E_BUSY,
        [EnumMember]
        E_EXTENDED,
        [EnumMember]
        E_DEPRECATED,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public enum HealthCheckLevel
    {
        [EnumMember]
        CH_INTERNAL,
        [EnumMember]
        CH_EXTERNAL,
        [EnumMember]
        CH_INTERACTIVE,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public enum PowerNotification
    {
        [EnumMember]
        PN_DISABLED,
        [EnumMember]
        PN_ENABLED,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public enum PowerReporting
    {
        [EnumMember]
        PR_NONE,
        [EnumMember]
        PR_STANDARD,
        [EnumMember]
        PR_ADVANCED,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public enum PowerState
    {
        [EnumMember]
        PS_UNKNOWN,
        [EnumMember]
        PS_ONLINE,
        [EnumMember]
        PS_OFF,
        [EnumMember]
        PS_OFFLINE,
        [EnumMember]
        PS_OFF_OFFLINE,
    }

    /*
    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public enum StatisticCategories
    {
        [EnumMember]
        All,
        [EnumMember]
        Manufacturer,
        [EnumMember]
        Upos,
    }
    */
    public class StatisticCategories
    {
        public const string All = "";
        public const string Manufacturer = "M_";
        public const string Upos = "U_";
    }

    //
    // Specific Data Types
    //

    //
    // Specific Enumerations
    //

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public enum WriteTagSections
    {
        [EnumMember]
        RFID_CWT_NONE,
        [EnumMember]
        RFID_CWT_ID,
        [EnumMember]
        RFID_CWT_USERDATA,
        [EnumMember]
        RFID_CWT_ALL,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public enum RFIDReadOptions
    {
        [EnumMember]
        RFID_RT_ID,
        [EnumMember]
        RFID_RT_FULLUSERDATA,
        [EnumMember]
        RFID_RT_PARTIALUSERDATA,
        [EnumMember]
        RFID_RT_ID_FULLUSERDATA,
        [EnumMember]
        RFID_RT_ID_PARTIALUSERDATA,
    }

    //
    // Constants
    //

    public class ExtendedError
    {
        public const int EFIRMWARE_BAD_FILE = 281;
        public const int ESTATS_ERROR = 280;
        public const int ESTATS_DEPENDENCY = 282;
    }

    public class StatisticProperties
    {
        public const string CommunicationErrorCount = "CommunicationErrorCount";
        public const string DeviceCategory = "DeviceCategory";
        public const string FirmwareRevision = "FirmwareRevision";
        public const string HoursPoweredCount = "HoursPoweredCount";
        public const string InstallationDate = "InstallationDate";
        public const string Interface = "Interface";
        public const string ManufactureDate = "ManufactureDate";
        public const string ManufacturerName = "ManufacturerName";
        public const string MechanicalRevision = "MechanicalRevision";
        public const string ModelName = "ModelName";
        public const string SerialNumber = "SerialNumber";
        public const string UnifiedPOSVersion = "UnifiedPOSVersion";
        public const string TagReadCount = "TagReadCount";
        public const string GoodTagWriteCount = "GoodTagWriteCount";
        public const string FailedTagWriteCount = "FailedTagWriteCount";
        public const string GoodTagLockCount = "GoodTagLockCount";
        public const string FailedTagLockCount = "FailedTagLockCount";
        public const string GoodTagDisableCount = "GoodTagDisableCount";
        public const string FailedTagDisableCount = "FailedTagDisableCount";
    }

    public class Wait
    {
        public const int FOREVER = -1;
    }

    public class RFIDProtocols
    {
        public const int RFID_PR_EPC0 = 1;
        public const int RFID_PR_0PLUS = 2;
        public const int RFID_PR_EPC1 = 4;
        public const int RFID_PR_EPC1G2 = 8;
        public const int RFID_PR_EPC2 = 16;
        public const int RFID_PR_ISO14443A = 4096;
        public const int RFID_PR_ISO14443B = 8192;
        public const int RFID_PR_ISO15693 = 12288;
        public const int RFID_PR_ISO180006B = 16384;
        public const int RFID_PR_OTHER = 16777216;
        public const int RFID_PR_ALL = 1073741824;
    }

    #endregion

    #region Version 1.2

    //
    // Event Polling
    //

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public class RFIDScannerEvent
    {
        [DataMember]
        public DataEvent DataEvent { get; set; }
        [DataMember]
        public DirectIOEvent DirectIOEvent { get; set; }
        [DataMember]
        public ErrorEvent ErrorEvent { get; set; }
        [DataMember]
        public OutputCompleteEvent OutputCompleteEvent { get; set; }
        [DataMember]
        public StatusUpdateEvent StatusUpdateEvent { get; set; }
        [DataMember]
        public DataContainedEvent DataContainedEvent { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public class RFIDScannerEventResponse
    {
        [DataMember]
        public DataEventResponse DataEventResponse { get; set; }
        [DataMember]
        public DataContainedEventResponse DataContainedEventResponse { get; set; }
        [DataMember]
        public DirectIOEventResponse DirectIOEventResponse { get; set; }
        [DataMember]
        public ErrorEventResponse ErrorEventResponse { get; set; }
        [DataMember]
        public OutputCompleteEventResponse OutputCompleteEventResponse { get; set; }
        [DataMember]
        public StatusUpdateEventResponse StatusUpdateEventResponse { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public class DataEvent
    {
        [DataMember]
        public string Source { get; set; }
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DateTime TimeStamp { get; set; }
        [DataMember]
        public int Status { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public class DataEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public class DirectIOEvent
    {
        [DataMember]
        public string Source { get; set; }
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DateTime TimeStamp { get; set; }
        [DataMember]
        public int EventNumber { get; set; }
        [DataMember]
        public int Data { get; set; }
        [DataMember]
        public object Obj { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public class DirectIOEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DirectIOData DirectIOData { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public class ErrorEvent
    {
        [DataMember]
        public string Source { get; set; }
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DateTime TimeStamp { get; set; }
        [DataMember]
        public ErrorCode ErrorCode { get; set; }
        [DataMember]
        public int ErrorCodeExtended { get; set; }
        [DataMember]
        public ErrorLocus ErrorLocus { get; set; }
        [DataMember]
        public ErrorResponse ErrorResponse { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public class ErrorEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public ErrorResponse ErrorResponse { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public class OutputCompleteEvent
    {
        [DataMember]
        public string Source { get; set; }
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DateTime TimeStamp { get; set; }
        [DataMember]
        public int OutputID { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public class OutputCompleteEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public class StatusUpdateEvent
    {
        [DataMember]
        public string Source { get; set; }
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DateTime TimeStamp { get; set; }
        [DataMember]
        public int Status { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public class StatusUpdateEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public enum ErrorLocus
    {
        [EnumMember]
        EL_INPUT,
        [EnumMember]
        EL_INPUT_DATA,
        [EnumMember]
        EL_OUTPUT,
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public enum ErrorResponse
    {
        [EnumMember]
        ER_CLEAR,
        [EnumMember]
        ER_CONTINUEINPUT,
        [EnumMember]
        ER_RETRY,
    }

    #endregion

    #region Version 1.3

    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/", ItemName = "PropertyName")]
    public class PropertyNameList : List<string>
    {
    }



    [CollectionDataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/", ItemName = "Parameter")]
    public class ParameterList : Dictionary<string, object>
    {
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public class DataContainedEvent
    {
        [DataMember]
        public string Source { get; set; }
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public DateTime TimeStamp { get; set; }
        [DataMember]
        public int Status { get; set; }
        [DataMember]
        public ParameterList Parameters { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public class DataContainedEventData
    {
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public bool SetDataEventEnabled { get; set; }
        [DataMember]
        public bool CallClearInputProperties { get; set; }
    }

    [DataContract(Namespace = "http://www.nrf-arts.org/UnifiedPOS/RFIDScanner/")]
    public class DataContainedEventResponse
    {
        [DataMember]
        public int EventID { get; set; }
        [DataMember]
        public bool SetDataEventEnabled { get; set; }
        [DataMember]
        public bool CallClearInputProperties { get; set; }
    }

    #endregion
}
